"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var classnames_1 = __importDefault(require("classnames"));
/**
 * add prefix to every `classnames` arguments
 * @param {string} CLS_PREFIX prefix
 * @param {string} seperator
 * @return {string} plain className
 */


var classPrefix = function classPrefix() {
  var CLS_PREFIX = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var seperator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '-';

  var addPrefix = function addPrefix(cls) {
    return !!CLS_PREFIX && !!cls ? "".concat(CLS_PREFIX).concat(seperator).concat(cls) : cls;
  };

  var loop = function loop(arg) {
    if (typeof arg === 'string' || typeof arg === 'number') {
      return addPrefix(arg);
    } else if (Array.isArray(arg) && arg.length) {
      return arg.map(loop);
    } else if (arg != null && (0, _typeof2["default"])(arg) === 'object') {
      var output = {};
      Object.entries(arg).forEach(function (_ref) {
        var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        output[addPrefix(key)] = value;
      });
      return output;
    }

    return arg;
  };

  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (args.length === 0) {
      return CLS_PREFIX;
    }

    return classnames_1["default"].apply(classnames_1, (0, _toConsumableArray2["default"])(args.map(loop)));
  };
};

exports["default"] = classPrefix;